function [Estimation]=EstimateTClosed(Samples)

Estimation.Means=mean(Samples,2);
Estimation.Covariances=cov(Samples');
while rcond(Estimation.Covariances)<1e-10
    disp('Singular covariance matrix in EstimateTClosed.m')  
    Estimation.Covariances=Estimation.Covariances+0.1*eye(size(Estimation.Covariances));
end
InvCovariances=inv(Estimation.Covariances);
[Dimension NumSamples]=size(Samples);
for NdxSample=1:NumSamples
    Difference=Samples(:,NdxSample)-Estimation.Means;
    Estimation.DistMahal(NdxSample)=Difference'*InvCovariances*Difference;
end

% Estimation by the logarithm of the Mahalanobis distance
Estimation.Rho=mean(log(sqrt(Estimation.DistMahal)));
if Estimation.Rho>log(Dimension)
    Estimation.Rho=log(Dimension);
    Estimation.DegreesFreedom=inf;
else
    Estimation.DegreesFreedom=fminbnd(@(x)((0.5*(psi(0.5*Dimension)-psi(0.5*x)-log(1/(x-2)))-Estimation.Rho)^2),...
        2.01,100);
end





