% TSOM demo: self organization

clear all

NumRowsMap=30;
NumColsMap=1;

NumPoints=40;
Vertices=[0 0 ; 0 1; 1 1; 1 0; 0 0];


NumSteps=100000;

SamplesTrain=rand(2,100000);


for Method=0:2
    Model{Method+1}=TrainTSOM(SamplesTrain,NumRowsMap,NumColsMap,Method,[],NumSteps);
end


SamplesTest=rand(2,10000);
for Method=0:2
    [Handle]=PlotTSOM(Model{Method+1},NumPoints);
    plot(Vertices(:,1),Vertices(:,2),'-g','LineWidth',1)
    axis([-0.05 1.05 -0.05 1.05])
    axis off
    hold off
        
    [ANLL,LogDensitiesProb,Respon] = TSOMANLLMEX(SamplesTest,Model{Method+1});
    
    [Maxima Indexes]=max(Respon);
    MyColors=hsv(NumRowsMap*NumColsMap);
    figure
    hold on
    for NdxUnit=1:NumRowsMap*NumColsMap
        NdxColor=mod(17*NdxUnit,NumRowsMap*NumColsMap)+1;
        plot(SamplesTest(1,find(Indexes==NdxUnit)),SamplesTest(2,find(Indexes==NdxUnit)),'xg',...
            'Color',MyColors(NdxColor,:));
    end
    title('Receptive fields')
end

